.ds MONTH1 January
.ds MONTH2 February
.ds MONTH3 March
.ds MONTH4 April
.ds MONTH5 May
.ds MONTH6 June
.ds MONTH7 July
.ds MONTH8 August
.ds MONTH9 September
.ds MONTH10 October
.ds MONTH11 November
.ds MONTH12 December
.ds MO \E*[MONTH\n[mo]]
.ds DY \*[MO] \n[dy], \n[year]

.TL
Assignment 3: Elevator Control Simulator Implementation
.AU
Quentin Wolkensperg [101157870]
.AI
COMP 3004 Winter 2024

\*[DY]

.EQ
delim $$
.EN

.SH
Elevator Simulator Use Cases
.RS
.SH
Use Case: Elevator Control System Centralized (Simulation)
.LP
.UL "Primary Actors:"
Elevator Control System (ECS), Elevator, Elevator User
.LP
.UL "Stakeholder and Interests:"
.br
Elevator User - wants the elevators to get them safely to their destination by behaving as expected
.LP
.UL "Precondition:"
Elevators installed and all parts function. (Simulator needs nothing to start)
.LP
.UL "Success Guarantee:"
Elevators moves rider to desired location timely.
.LP
.UL "Main Success Scenario:"
.nr step 1 1
.af step 1
.IP \n[step]. 4
User calls elevator by pressing either up or down button it lights up when pressed, floor marked as needing service by ECS.
.IP \n+[step].
ECS picks the elevator that will reach the user the fastest (either floor is on route to a current elevators direction or elevator is stalled closer, elevators that are not on route to the floor fulfilling a request will respond last).
.IP \n+[step].
Elevator reaches requested floor, illuminated button turns off and floor is unmarked by ECS, bell rings and doors open for 10 seconds
.IP \n+[step].
Users may leave or enter elevator.
.IP \n+[step].
Once the door closes the elevator will proceed to selected floors (once selected) or continue to other requested floors.
.IP \n+[step].
As floors are passed elevator display is updated to display current floor and ECS is updated.
.IP \n+[step].
If requested floor on route is marked requested fulfill that request as per step 3.
.IP \n+[step].
Once elevator reaches one of the selected floors unselect that floor and open doors, ring bell and open door for 10 seconds.
.IP \n+[step].
Proceed to all selected/requested floors until all selected floors have been unselected.
.IP \n+[step].
If nothing to do wait for request or selection.
.LP
.UL "Extensions:"
.IP 3,8a.
User wants elevators doors to close faster or stay open longer
.RS
.IP 3,8a1. 6
User can use control buttons located in elevator cab.
.RS
.IP 3,8a1a: 7
User presses open door button
.IP 3,8a1a1. 8
Door stays open longer than default time
.IP 3,8a1b: 7
User presses close door button
.IP 3,8a1b1. 8
Door closes faster than default time
.RE
.RE
.IP 3,8b.
Door in obstructed when closing
.RS
.IP 3,8b1. 6
Control system stops door from closing and opens it.
.RS
.IP 3,8b2a: 7
This happens repetitively in a short period of time.
.IP 3,8b2a1. 8
Warning sound played and elevator display shows a warning.
.RE
.RE
.IP 3,8c.
Elevator receives "Overload" alarm signal when cargo load exceeds capacity.
.RS
.IP 3,8c1. 6
Elevator does not move, audio and text display presented to passengers asking load to be reduced. Once reduced elevator will attempt to move again.
.RE
.IP *a.
Elevator receives "Help" alarm signal (User presses "Help" button)
.RS
.IP *a1.
Passenger is connected to building safety service through voice connection.
.RS
.IP *a1a: 6
5 seconds elapses with no response
.IP *a1a1. 7
911 emergency call is placed
.RE
.RE
.IP *b.
ECS receives "Fire" signal from building/elevator itself.
.RS
.IP *b1.
Elevator moves to safe floor, audio and text display informs passengers of emergency.
.RE
.IP *c.
Elevator receives "Power Out" alarm signal.
.RS
.IP *c1.
Elevator moves to safe floor, audio and text display informs passengers of emergency.
.RE
.SH
Use Case: Elevator Control System Distributed (Simulation)
.LP
.UL "Primary Actors:"
Elevators, Elevator User
.LP
.UL "Stakeholder and Interests:"
.br
Elevator User - wants the elevators to get them safely to their destination by behaving as expected
.LP
.UL "Precondition:"
Elevators installed and all parts function. (Simulator needs nothing to start)
.LP
.UL "Success Guarantee:"
Elevators moves rider to desired location timely.
.LP
.UL "Main Success Scenario:"
.nr step 1 1
.af step 1
.IP \n[step]. 4
User calls elevator by pressing either up or down button it lights up when pressed, signal is sent to all elevators that floor was called containing the floor number and direction.
.IP \n+[step].
All able (determined by elevator itself) respond to call. Elevators run a routine to determine when this floor is visited based on the elevators current state and what order floors are visited.
.IP \n+[step].
An elevator reaches requested floor, illuminated button turns off, signal is sent to all elevators that this floor has been visited, other elevators update state (i.e respond to other calls), bell rings and doors open for 10 seconds.
.IP \n+[step].
Users may leave or enter elevator.
.IP \n+[step].
Once the door closes the elevator will proceed to selected floors (once selected) or continue to other requested floors.
.IP \n+[step].
As floors are passed elevator display is updated to display current floor, elevator also updates internal state.
.IP \n+[step].
Once elevator reaches one of the selected floors elevator updates internal state (direction and removal of visited floor from stack) and open doors, ring bell and open door for 10 seconds.
.IP \n+[step].
Proceed to all selected/requested floors until all selected floors in elevators internal state have been visited.
.IP \n+[step].
If nothing to do wait for request or selection.
.LP
.UL "Extensions:"
.IP 3,8a.
User wants elevators doors to close faster or stay open longer
.RS
.IP 3,8a1. 6
User can use control buttons located in elevator cab.
.RS
.IP 3,8a1a: 7
User presses open door button
.IP 3,8a1a1. 8
Door stays open longer than default time
.IP 3,8a1b: 7
User presses close door button
.IP 3,8a1b1. 8
Door closes faster than default time
.RE
.RE
.IP 3,8b.
Door in obstructed when closing
.RS
.IP 3,8b1. 6
Control system stops door from closing and opens it.
.RS
.IP 3,8b2a: 7
This happens repetitively in a short period of time.
.IP 3,8b2a1. 8
Warning sound played and elevator display shows a warning.
.RE
.RE
.IP 3,8c.
Elevator receives "Overload" alarm signal when cargo load exceeds capacity.
.RS
.IP 3,8c1. 6
Elevator does not move, audio and text display presented to passengers asking load to be reduced. Once reduced elevator will attempt to move again.
.RE
.IP *a.
Elevator receives "Help" alarm signal (User presses "Help" button)
.RS
.IP *a1.
Passenger is connected to building safety service through voice connection.
.RS
.IP *a1a: 6
5 seconds elapses with no response
.IP *a1a1. 7
911 emergency call is placed
.RE
.RE
.IP *b.
Elevator receives "Fire" signal from building/other elevators/itself.
.RS
.IP *b1.
Elevator moves to safe floor, audio and text display informs passengers of emergency.
.RE
.IP *c.
Elevator receives "Power Out" alarm signal.
.RS
.IP *c1.
Elevator moves to safe floor, audio and text display informs passengers of emergency.
.RE
.RE

.SH
Elevator Simulation Design
.RS

.SH
UML Class Diagrams
.RS

.SH
Centralized System
.RS
See
.ft C
a3UMLdiag.png
.PDFPIC "a3UMLdiag.pdf"
.RE


.RE

.SH
Sequence Diagrams
.RS
.SH
Success Scenario 1
.RS
All at once elevator request.
See
.ft C
seq1.png
.PDFPIC "seq1.pdf"
.RE

.SH
Success Scenario 2
.RS
Midway elevator request.
See
.ft C
seq2.png
.PDFPIC "seq2.pdf"
.RE

.SH
Safety Scenario: Obstructed Door
.RS
See
.ft C
safseqobs.png
.PDFPIC "safseqobs.pdf"
.RE

.SH
Safety Scenario: "Overload" Alarm
.RS
See
.ft C
safseqover.png
.PDFPIC "safseqover.pdf"
.RE

.SH
Safety Scenario: "Help" Alarm
.RS
See
.ft C
safseqhelp.png
.PDFPIC "safseqhelp.pdf"
.RE

.SH
Safety Scenario: "Fire" Alarm
.RS
See
.ft C
safseqfire.png
.PDFPIC "safseqfire.pdf"
.RE

.SH
Safety Scenario: "Power Out" Alarm
.RS
See
.ft C
safseqpower.png
.PDFPIC "safseqpower.pdf"
.RE

.RE

.SH
State Diagrams
.RS

.SH
State Diagram Elevator
.RS
See
.ft C
cevstate.png
.PDFPIC "cevstate.pdf"
.RE

.SH
State Diagram ECS
.RS
See
.ft C
ecsstate.png
.PDFPIC "ecsstate.pdf"
.RE
.RE

.SH
Requirements Traceability Matrix
.RS
.PP
I did a bad job on this but got no comments from the TA that marked me if you could just direct me to the readings if you remember for the Traceability Matrices because I feel like I read all I need to know on them but I don't know what I'm missing.
.RS
.TS
allbox;
c c c c c
l l l l l.
Requirement	ECS	Elevator	Buttons	Passenger
R1: Dispatch nearest elevator when called	\[OK]	\[OK]	\[OK]
R2: Assign requested floor to elevator	\[OK]	\[OK]
R3: Open door upon reaching the destination floor	 	\[OK]
R4: Close door after a fixed time or manually	 	\[OK]	\[OK]
R5: Handle elevator overload	 	\[OK]
R6: Handle emergency situations	\[OK]	\[OK]	\[OK]
.TE
.RE
.RE
