#include "eventlogger.h"
#include <QDebug>

// Popular singleton pattern for event logging to QPlainText
EventLogger* EventLogger::instance = nullptr;

EventLogger& EventLogger::getInstance()
{
    if (!instance) {
        instance = new EventLogger();
    }
    return *instance;
}

EventLogger::EventLogger(QObject* parent)
    : QObject(parent), textEdit(nullptr)
{
}

EventLogger::~EventLogger()
{
}

void EventLogger::setTextEdit(QPlainTextEdit* textEdit)
{
    this->textEdit = textEdit;
}

void EventLogger::logEvent(const QString& eventDescription)
{
    if (textEdit) {
        textEdit->appendPlainText("> " + eventDescription);
    }
    //qInfo() << eventDescription.toStdString().c_str();
}
